import java.util.*;


class simulator {

	public void addDynamicObject(Object o) {
		if (o instanceof dynamicObject)
			dynamicObjects.add((dynamicObject)o);
	}

	public void addActiveObject(Object o) {
		if (o instanceof activeObject)
			activeObjects.add((activeObject)o);
	}

	public void addDescribableObject(Object o) {
		if (o instanceof describableObject)
			describableObjects.add((describableObject)o);
	}


	public void run(double duration) {

		while (currentTime < duration) {
			streamOutCurrentDescriptions();
			computeActuations();
			computeDynamics();
			currentTime += timeStep;
		}
	}


	void computeDynamics() {
		for (dynamicObject dynObj : dynamicObjects) {
			dynObj.computeDynamics(timeStep);
		}

	}

	void computeActuations() {
		for (activeObject actObj : activeObjects) {
			actObj.actuation();
		}

	}

	void streamOutCurrentDescriptions() {
		System.out.print(currentTime);
		System.out.print(",\t");
		for (describableObject descObj : describableObjects) {
			// To be coded
		}
		System.out.print("\n");
	}

	ArrayList<dynamicObject> dynamicObjects = new ArrayList<dynamicObject>();
	ArrayList<activeObject> activeObjects = new ArrayList<activeObject>();
	ArrayList<describableObject> describableObjects = new ArrayList<describableObject>();
	double timeStep = 0.01;
	double currentTime = 0.0;

}
